﻿using Syncfusion.DataSource;
using Syncfusion.DataSource.Extensions;
using Syncfusion.ListView.XForms;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using Xamarin.Forms;

namespace Grouping
{
    public partial class Page2 : ContentPage
    {
        #region Fields

        Random random = new Random();
        ContactsViewModel1 viewModel;
        #endregion

        #region Constructor

        public Page2()
        {
            InitializeComponent();
            listView.ItemTapped += ListView_ItemTapped;
            listView.DataSource.SortDescriptors.Add(new SortDescriptor { PropertyName = "Group", Direction = ListSortDirection.Ascending });
        }

        #endregion

        #region CallBacks

        private void ListView_ItemTapped(object sender, Syncfusion.ListView.XForms.ItemTappedEventArgs e)
        {
            this.viewModel = this.BindingContext as ContactsViewModel1;
            if (e.ItemData is GroupResult)
                return;

            viewModel.Contactsinfo.Remove(e.ItemData as Contacts);
        }

        private void RemoveItemInGroup_Clicked(object sender, EventArgs e)
        {
            this.viewModel = this.BindingContext as ContactsViewModel1;
            var item = listView.DataSource.DisplayItems[1] as Contacts;

            viewModel.Contactsinfo.Remove(item as Contacts);
        }

        private void AddItemInGroup_Clicked(object sender, EventArgs e)
        {
            this.viewModel = this.BindingContext as ContactsViewModel1;
            viewModel.UpdateViewModel(1);
        }

        private void NextPage_Clicked(object sender, EventArgs e)
        {
            this.Navigation.PushAsync(new Page3());
        }

        #endregion
    }
}
